package	jp.co.sds_corp.report.source;

import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.config.IConfiguration;

/**
* データを取得するクラスの定義です。
*/
public interface ISource
{
	/**
	* 設定情報で初期化します。
	* @param    config  設定情報
	*/
	public void init( IConfiguration config ) throws Exception;
	/**
	* 初期情報の変換に使用するリソースを設定します。
	* @param	prop	リソース
	*/
	public void setProperty( CmnProperty prop );
	/**
	* 初期情報の変換に使用するリソースを返します。
	* @return	リソース
	*/
	public CmnProperty getProperty();
	/**
	* データ格納beanを設定します。
	* @param	var		設定するデータ
	*/
	public void setBean( GenericBean var );
	/**
	* データ格納beanを取得します。
	* @return	データ格納bean
	*/
	public GenericBean getBean();

	/**
	* データを取得します。
	*/
	public void execute() throws Exception;
	/**
	* データの取得を終了します。
	*/
	public void exit();
}
