package	jp.co.sds_corp.report.tool;

import java.util.Iterator;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.sds_corp.report.IReport;
import jp.co.sds_corp.report.ReportFactory;
import jp.co.sds_corp.report.source.GenericBean;
import jp.co.sds_corp.util.config.DOMConfiguration;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class PrintServlet extends HttpServlet
{
	private static final long serialVersionUID = 1L;
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);

	public void doGet( HttpServletRequest request, HttpServletResponse response )
	{
		doPost( request, response );
	}
	public void doPost( HttpServletRequest request, HttpServletResponse response )
	{
		try {
			print( request, response );
		} catch ( Exception ex ) {
			ex.printStackTrace();
		}
	}

	public void print( HttpServletRequest request, HttpServletResponse response )
		throws Exception
	{
		String target = request.getParameter( "target" );
		String file = System.getProperty( "report.config" );
		DOMConfiguration config = new DOMConfiguration( file );
		IConfiguration c = null;
		Iterator<IConfiguration> itr = config.getChilds( "Report" );
		while ( itr.hasNext()) {
			IConfiguration tmp = (IConfiguration )itr.next();
			String name = tmp.getAttributes().get( "name", null );
			if ( name != null && name.equals( target )) {
				c = tmp;
				break;
			}
		}
		if ( c == null ) {
			throw( new Exception( "target not found. [" + target + "]" ));
		}
		IReport	report = ReportFactory.createReport( c );
		if ( report.isDebug()) {
			logger.debug( "print " + target );
		}
		GenericBean bean = new GenericBean();
		report.setAttribute( "bean", bean );
		report.setAttribute( "Servlet", this );

		ServletOutputStream out = response.getOutputStream();
		report.setupResponse( out );
		report.print( out );
		out.flush();
		out.close();
		report.exit();
	}

}
